"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = DB_HANDLER;
const grab_dsql_connection_1 = __importDefault(require("../../grab-dsql-connection"));
/**
 * # DSQL user read-only DB handler
 * @requires DSQL_DB_CONN - Gobal Variable for Datasquirel Database
 */
function DB_HANDLER(...args) {
    return __awaiter(this, void 0, void 0, function* () {
        var _a;
        const CONNECTION = (0, grab_dsql_connection_1.default)();
        try {
            if (!CONNECTION)
                throw new Error("No Connection provided to DB_HANDLER function!");
            const results = yield CONNECTION.query(...args);
            return JSON.parse(JSON.stringify(results));
        }
        catch (error) {
            (_a = global.ERROR_CALLBACK) === null || _a === void 0 ? void 0 : _a.call(global, `DB_HANDLER Error`, error);
            return {
                success: false,
                error: error.message,
            };
        }
        finally {
            yield (CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end());
        }
    });
}
