"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = importMariadbDatabase;
const child_process_1 = require("child_process");
const os_1 = __importDefault(require("os"));
const conn_db_handler_1 = __importDefault(require("../db/conn-db-handler"));
function importMariadbDatabase(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbFullName, targetFilePath, mariadbHost, mariadbPass, mariadbUser, }) {
        const mysqlPath = os_1.default.platform().match(/win/i)
            ? "'" +
                "C:\\Program Files\\MySQL\\MySQL Server 8.0\\bin\\mysql.exe" +
                "'"
            : "mysql";
        const finalMariadbUser = mariadbUser || process.env.DSQL_DB_USERNAME;
        const finalMariadbHost = mariadbHost || process.env.DSQL_DB_HOST;
        const finalMariadbPass = mariadbPass || process.env.DSQL_DB_PASSWORD;
        yield (0, conn_db_handler_1.default)(global.DSQL_DB_CONN, `CREATE DATABASE IF NOT EXISTS ${dbFullName}`);
        const cmd = `${mysqlPath} -u ${finalMariadbUser} -h ${finalMariadbHost} -p"${finalMariadbPass}" ${dbFullName} < ${targetFilePath}`;
        let execSyncOptions = {
            encoding: "utf-8",
        };
        const importDb = (0, child_process_1.execSync)(cmd, execSyncOptions);
        return importDb;
    });
}
